let print_tree trees chars =
  let rec print = function
      Tree.Node (tag, children) ->
	begin
	  output_string stdout (Tag.string_of_open_tag tag);
	  List.iter print children;
	  output_string stdout (Tag.string_of_close_tag tag)
	end
    | Tree.Space (start, stop) | Tree.Chars (start, stop) ->
	output stdout chars start (stop - start)
  in List.iter print trees

let print_tree_with_stack trees chars =
  let stack=Stack.create () in
  let push_on_stack tss =
    let rec push_aux = function
	[] -> ()
      | t::ts ->
	  Stack.push (t,false) stack;
	  push_aux ts
    in
      push_aux (List.rev tss)
  in
    push_on_stack trees;
    try
      while true do
	let (t,visited)=Stack.pop stack in
	  match t with
	    | Tree.Space (start, stop) 
	    | Tree.Chars (start, stop) ->
		output stdout chars start (stop - start)
	    | Tree.Node(tag,children) -> 
		if visited then
		  output_string stdout (Tag.string_of_close_tag tag)
		else
		  begin
		    output_string stdout (Tag.string_of_open_tag tag);
		    Stack.push (t,true) stack;
		    push_on_stack children
		  end
      done;
    with
	Stack.Empty -> ()
