(* for EM 0 is off, 1 is on, 2 is S *)

type t = B | I | PL | TT | U | EM of int  | SIZE of int | COLOR of char;;

let simple_string_of_tag = function
  | B -> "B"
  | I -> "I"
  | PL -> "PL"
  | TT -> "TT"
  | U -> "U"
  | EM 2 -> "S" 
  | EM _ -> "EM"
  | SIZE n -> string_of_int n
  | COLOR c -> String.make 1 c

let size = function
    PL | TT | EM 0 | EM 1 -> 9
  | _ -> 7

let string_of_open_tag tag = "<"^(simple_string_of_tag tag)^">"

let string_of_close_tag tag = "</"^(simple_string_of_tag tag)^">"

let print fmt tag = Format.fprintf fmt "%s" (simple_string_of_tag tag)
