(* positions start at 0 *)
(* start is inclusive *)
(* stop is exclusive *)

(* childs should be sorted and not overlap *)

type t =
    Node of Tag.t * (t list)
  | Space of (int * int)
  | Chars of (int * int)

let rec size = function
    Node (tag, children) ->
      (Tag.size tag) + (List.fold_left (fun sum tree -> sum + (size tree)) 0 children)
  | _ -> 0

let sizes trees =
  List.fold_left (fun sum tree -> sum + (size tree)) 0 trees
